/*
  Various auto-generated tables for the BCH3 decoder.
  F. R. Kschischang, Sept. 22, 2010
*/

// generator polynomial 1 + x^{1} + x^{7} 

#define GFQ 128
#define GFq 127
#define GFm 7
#define BITMASK (0x007F)
typedef unsigned int GFel;
#define PLUS(x,y) ((x)^(y))
#define TIMES(x,y) ((x)==0?0:((y)==0?0:EXP[(LOG[x]+LOG[y])%(GFq)]))

/*
Auto-generated table of roots of the depressed cubic
g(x) = x^3 + x + c for those nonzero c that cause
g(x) to have 3 distinct roots in GF(128). Given two roots,
the third root is their sum.
*/

GFel DepCubicRoot[256] = {
   0,   0,   0,   0,  25,  36,   0,   0,   8,  71,   0,   0,  15,  96,
   0,   0,   0,   0,   0,   0,   2, 116,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  53,  64,   0,   0,  33,  74,   0,   0,  45,  85,
   0,   0,  62,  73,   0,   0,   0,   0,  13, 115,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  39,  87,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  20,  32,   0,   0,   0,   0,  10,  35,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  18,  70,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   4, 106,   0,   0,
   0,   0,  42,  81,   0,   0,  29,  68,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  14,  22,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  54,  91,
  16,  44,   0,   0,   0,   0,   0,   0,   0,   0,  59,  92,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   6,  72,   0,   0};

/*
Auto-generated table of roots of the simple cubic
g(x) = x^3 + c for those nonzero c that cause
g(x) to have 3 distinct roots in GF(128). Given two roots,
the third root is their sum.
*/

GFel CubeRoot[256] = {
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0};

/*
Auto-generated table of roots of the depressed quadratic
g(x) = x^2 + x + c for those nonzero c that cause
g(x) to have 2 distinct roots in GF(128).
*/

GFel DepQuadRoot[256] = {
   0,   0,   0,   0,  20,  21,   0,   0,  22,  23,   0,   0,   2,   3,
   0,   0, 114, 115,   0,   0, 102, 103,   0,   0, 100, 101,   0,   0,
 112, 113,   0,   0,  18,  19,   0,   0,   6,   7,   0,   0,   4,   5,
   0,   0,  16,  17,   0,   0,  96,  97,   0,   0, 116, 117,   0,   0,
 118, 119,   0,   0,  98,  99,   0,   0,  64,  65,   0,   0,  84,  85,
   0,   0,  86,  87,   0,   0,  66,  67,   0,   0,  50,  51,   0,   0,
  38,  39,   0,   0,  36,  37,   0,   0,  48,  49,   0,   0,  82,  83,
   0,   0,  70,  71,   0,   0,  68,  69,   0,   0,  80,  81,   0,   0,
  32,  33,   0,   0,  52,  53,   0,   0,  54,  55,   0,   0,  34,  35,
   0,   0, 122, 123,   0,   0, 110, 111,   0,   0, 108, 109,   0,   0,
 120, 121,   0,   0,   8,   9,   0,   0,  28,  29,   0,   0,  30,  31,
   0,   0,  10,  11,   0,   0, 104, 105,   0,   0, 124, 125,   0,   0,
 126, 127,   0,   0, 106, 107,   0,   0,  26,  27,   0,   0,  14,  15,
   0,   0,  12,  13,   0,   0,  24,  25,   0,   0,  58,  59,   0,   0,
  46,  47,   0,   0,  44,  45,   0,   0,  56,  57,   0,   0,  72,  73,
   0,   0,  92,  93,   0,   0,  94,  95,   0,   0,  74,  75,   0,   0,
  40,  41,   0,   0,  60,  61,   0,   0,  62,  63,   0,   0,  42,  43,
   0,   0,  90,  91,   0,   0,  78,  79,   0,   0,  76,  77,   0,   0,
  88,  89,   0,   0};

/*
Auto-generated table of square roots of the elements of GF(128).
*/

GFel SquareRoot[128] = {
   0,   1,  18,  19,   2,   3,  16,  17,  36,  37,  54,  55,  38,  39,
  52,  53,   4,   5,  22,  23,   6,   7,  20,  21,  32,  33,  50,  51,
  34,  35,  48,  49,  72,  73,  90,  91,  74,  75,  88,  89, 108, 109,
 126, 127, 110, 111, 124, 125,  76,  77,  94,  95,  78,  79,  92,  93,
 104, 105, 122, 123, 106, 107, 120, 121,   8,   9,  26,  27,  10,  11,
  24,  25,  44,  45,  62,  63,  46,  47,  60,  61,  12,  13,  30,  31,
  14,  15,  28,  29,  40,  41,  58,  59,  42,  43,  56,  57,  64,  65,
  82,  83,  66,  67,  80,  81, 100, 101, 118, 119, 102, 103, 116, 117,
  68,  69,  86,  87,  70,  71,  84,  85,  96,  97, 114, 115,  98,  99,
 112, 113};
GFel Pow2[128] = {
   0,   1,   4,   5,  16,  17,  20,  21,  64,  65,  68,  69,  80,  81,
  84,  85,   6,   7,   2,   3,  22,  23,  18,  19,  70,  71,  66,  67,
  86,  87,  82,  83,  24,  25,  28,  29,   8,   9,  12,  13,  88,  89,
  92,  93,  72,  73,  76,  77,  30,  31,  26,  27,  14,  15,  10,  11,
  94,  95,  90,  91,  78,  79,  74,  75,  96,  97, 100, 101, 112, 113,
 116, 117,  32,  33,  36,  37,  48,  49,  52,  53, 102, 103,  98,  99,
 118, 119, 114, 115,  38,  39,  34,  35,  54,  55,  50,  51, 120, 121,
 124, 125, 104, 105, 108, 109,  56,  57,  60,  61,  40,  41,  44,  45,
 126, 127, 122, 123, 110, 111, 106, 107,  62,  63,  58,  59,  46,  47,
  42,  43};
GFel Pow3[128] = {
   0,   1,   8,  15,  64,  85, 120, 107,  12,  69,  39, 104,  73,  20,
  82,   9,  96, 119,  36,  53,  62,  61,  74,  79,  68,  27,  35, 122,
  31,  84,  72,   5,  10,  51,  49,  14,  38,  11,  45,   6, 117,   4,
 109,  26,  92,  57, 116,  23,  44,   3,  91, 114,  30,  37,  89, 100,
 123,  28,  47,  78,  76,  63,  40,  93,  80, 113,  29,  58,  13,  56,
 112,  67,  54,  95,  88,  55, 110,  19,  48,  75,  33,  22,  32,  17,
  98,  65,  83, 118, 111,  16,  77,  52,  41,  66,  59,  86, 102, 127,
  24,   7,  87,  90,  25,  18, 115,  34,  46, 121,  71,   2,  42, 105,
  81,  94,  99, 106, 126, 101, 124,  97, 108,  43, 125,  60,  70,  21,
 103,  50};
GFel Pow5[128] = {
   0,   1,  32,  51,  24,  27, 116, 101,  10,  99, 106,  17,  39,  76,
  11, 114,  70,  67,  72,  95, 110, 105,  44,  57, 123,  22,  53,  74,
 102,   9, 100,  25, 115,  20,  80,  37,  54,  83,  89,  46, 109,  98,
  14,  19,  29,  16,  50,  45,  66,  33,  79,  62,  55,  86, 118,   5,
 107,  96,  38,  63,  43,  34,  42,  49,  68, 125,  15,  36,  60,   7,
  59,  18,  87,   6,  92,  31,  26,  73,  93,  28,  13,  48, 104,  71,
  69, 122, 108,  65,  41, 124,  12,  75,  84,   3,  61, 120, 112,  47,
  56, 117,  85,   8,  81,  30, 119,  64, 127,  90, 103,  82,  35,   4,
  78,  21,  40,  97,  91,   2, 113,  58, 126,  77,  88, 121,  94, 111,
  52,  23};
GFel Reciprocal[128] = {
   0,   1,  65, 126,  97,  42,  63,  54, 113,  18,  21,  74,  94,  79,
  27, 103, 121,  92,   9, 112,  75,  10,  37,  68,  47,  35, 102,  14,
  76,  71, 114, 110, 125,  91,  46,  25,  69,  22,  56,  61, 100, 119,
   5,  96,  83, 123,  34,  24,  86, 116,  80,  52,  51,  81,   7,  62,
  38,  60,  98,  73,  57,  39,  55,   6, 127,   2, 108,  84,  23,  36,
  77,  29,  99,  59,  11,  20,  28,  70,  95,  13,  50,  53, 122,  44,
  67, 109,  48, 117, 104, 107, 124,  33,  17, 120,  12,  78,  43,   4,
  58,  72,  40, 118,  26,  15,  88, 106, 105,  89,  66,  85,  31, 115,
  19,   8,  30, 111,  49,  87, 101,  41,  93,  16,  82,  45,  90,  32,
   3,  64};
GFel EXP[127] = {
   1,   2,   4,   8,  16,  32,  64,   3,   6,  12,  24,  48,  96,  67,
   5,  10,  20,  40,  80,  35,  70,  15,  30,  60, 120, 115, 101,  73,
  17,  34,  68,  11,  22,  44,  88,  51, 102,  79,  29,  58, 116, 107,
  85,  41,  82,  39,  78,  31,  62, 124, 123, 117, 105,  81,  33,  66,
   7,  14,  28,  56, 112,  99,  69,   9,  18,  36,  72,  19,  38,  76,
  27,  54, 108,  91,  53, 106,  87,  45,  90,  55, 110,  95,  61, 122,
 119, 109,  89,  49,  98,  71,  13,  26,  52, 104,  83,  37,  74,  23,
  46,  92,  59, 118, 111,  93,  57, 114, 103,  77,  25,  50, 100,  75,
  21,  42,  84,  43,  86,  47,  94,  63, 126, 127, 125, 121, 113,  97,
  65};
int LOG[128] = {
  -1,   0,   1,   7,   2,  14,   8,  56,   3,  63,  15,  31,   9,  90,
  57,  21,   4,  28,  64,  67,  16, 112,  32,  97,  10, 108,  91,  70,
  58,  38,  22,  47,   5,  54,  29,  19,  65,  95,  68,  45,  17,  43,
 113, 115,  33,  77,  98, 117,  11,  87, 109,  35,  92,  74,  71,  79,
  59, 104,  39, 100,  23,  82,  48, 119,   6, 126,  55,  13,  30,  62,
  20,  89,  66,  27,  96, 111,  69, 107,  46,  37,  18,  53,  44,  94,
 114,  42, 116,  76,  34,  86,  78,  73,  99, 103, 118,  81,  12, 125,
  88,  61, 110,  26,  36, 106,  93,  52,  75,  41,  72,  85,  80, 102,
  60, 124, 105,  25,  40,  51, 101,  84,  24, 123,  83,  50,  49, 122,
 120, 121};
