/*
  Various auto-generated tables for the BCH3 decoder.
  F. R. Kschischang, Sept. 22, 2010
*/

// generator polynomial 1 + x^{2} + x^{3} + x^{4} + x^{8}

#define GFQ 256
#define GFq 255
#define GFm 8
#define BITMASK (0x00FF)
typedef unsigned int GFel;
#define PLUS(x,y) ((x)^(y))
#define TIMES(x,y) ((x)==0?0:((y)==0?0:EXP[(LOG[x]+LOG[y])%(GFq)]))

/*
Auto-generated table of roots of the depressed cubic
g(x) = x^3 + x + c for those nonzero c that cause
g(x) to have 3 distinct roots in GF(256). Given two roots,
the third root is their sum.
*/

GFel DepCubicRoot[512] = {
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0, 104, 186,   2,  76,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  49, 213,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  30, 142,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  15, 114,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  85, 160,   0,   0,   0,   0,   0,   0,   0,   0,  25,  35,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  62, 199,   0,   0,   0,   0,   4, 153,   0,   0,
   0,   0,  41,  75,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  68, 188,  48, 146,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  89, 173,   0,   0,   0,   0,   0,   0,  97, 129,   0,   0, 103, 166,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  14,  71,   0,   0,  24, 168,   0,   0,   0,   0,  67, 131,
   0,   0,   0,   0,   0,   0,   9, 151,   0,   0,   0,   0,  45,  92,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  43,  83,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  56, 155,   0,   0,   0,   0,   0,   0,  29, 133,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  10,  99,  42, 221,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  39,  93,   0,   0,  26, 102,   0,   0,  84, 140,  19, 101,   0,   0,
   0,   0,   0,   0,  88, 148,   0,   0,   0,   0,  18, 170,   0,   0,
   0,   0,  22, 200,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  54, 145,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  61, 203,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,  11, 215,  69, 147,  53, 136,
   0,   0,   0,   0,   0,   0,   0,   0,  16,  79,   0,   0,   0,   0,
  27,  65,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  37, 128,  55, 150,   0,   0,   0,   0, 115, 172,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0};

/*
Auto-generated table of roots of the simple cubic
g(x) = x^3 + c for those nonzero c that cause
g(x) to have 3 distinct roots in GF(256). Given two roots,
the third root is their sum.
*/

GFel CubeRoot[512] = {
   0,   0,   1, 214,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  97, 170,   2, 177,   0,   0,  68, 152,   0,   0,  58,  75,   0,   0,
   0,   0,   3, 100,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  35, 155,   0,   0, 119, 133,   0,   0,   0,   0,  59, 156,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  92, 159,   0,   0,
   0,   0,  15, 230,  98, 175,  32, 223,  49, 217,   0,   0,  86, 140,
   0,   0,   0,   0, 108, 145,  64, 163,   0,   0,  25, 201,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,  67, 135,  71, 187,   0,   0,
  73, 139,   0,   0,   8, 246,  51,  89,   0,   0,  30, 207,  81, 148,
   0,   0,   4, 123,   0,   0,   0,   0,   0,   0,  78, 147,   0,   0,
  34,  76,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,  45, 136,   0,   0,   0,   0,   0,   0,
   0,   0,   5, 169, 125, 183,  82, 161,   0,   0,  44,  94,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 116, 150, 104, 130,
   0,   0,   0,   0,  85, 190,  50, 143, 121, 181,   0,   0,   0,   0,
   0,   0,   0,   0,   7,  24,   0,   0,   0,   0,  41, 222,   0,   0,
   0,   0,   0,   0,   0,   0,   9,  33,   0,   0,  91, 128,   0,   0,
   0,   0,   6, 200,   0,   0,   0,   0,   0,   0,   0,   0,  63, 216,
   0,   0,  14,  48,   0,   0,   0,   0,  95, 164,   0,   0,   0,   0,
   0,   0,  39, 199,   0,   0,   0,   0,   0,   0, 115, 137,  54, 198,
   0,   0,   0,   0,   0,   0,  29, 171,   0,   0,  36, 132,  10,  69,
   0,   0,   0,   0,   0,   0,  77, 185,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
  52,  65,   0,   0,   0,   0,   0,   0,   0,   0,  22,  47,   0,   0,
  43,  70,  46, 193,   0,   0,   0,   0,   0,   0, 107, 142,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,  42, 144,   0,   0,  19, 134,
  56, 192,   0,   0,  23, 238,  26, 174,  13,  87,   0,   0,   0,   0,
   0,   0,   0,   0,  18,  66,   0,   0,  17,  38,   0,   0, 101, 176,
 111, 154, 102, 178,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  16, 225,  74, 166, 126, 173,  37,  83,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
 112, 157,   0,   0, 122, 168,   0,   0,  11, 146,   0,   0,  28,  96,
   0,   0,   0,   0,   0,   0,   0,   0,  20, 138,   0,   0,   0,   0,
  12, 129,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  53, 151,
   0,   0,   0,   0,   0,   0,  61,  84,  88, 188,   0,   0,   0,   0,
  60, 131,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  27,  99,
  21,  72,   0,   0,   0,   0,   0,   0};

/*
Auto-generated table of roots of the depressed quadratic
g(x) = x^2 + x + c for those nonzero c that cause
g(x) to have 2 distinct roots in GF(256).
*/

GFel DepQuadRoot[512] = {
   0,   0, 214, 215, 232, 233,  62,  63, 234, 235,  60,  61,   2,   3,
 212, 213,  44,  45, 250, 251, 196, 197,  18,  19, 198, 199,  16,  17,
  46,  47, 248, 249, 238, 239,  56,  57,   6,   7, 208, 209,   4,   5,
 210, 211, 236, 237,  58,  59, 194, 195,  20,  21,  42,  43, 252, 253,
  40,  41, 254, 255, 192, 193,  22,  23,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,  36,  37, 242, 243, 204, 205,  26,  27, 206, 207,  24,  25,
  38,  39, 240, 241,   8,   9, 222, 223, 224, 225,  54,  55, 226, 227,
  52,  53,  10,  11, 220, 221, 202, 203,  28,  29,  34,  35, 244, 245,
  32,  33, 246, 247, 200, 201,  30,  31, 230, 231,  48,  49,  14,  15,
 216, 217,  12,  13, 218, 219, 228, 229,  50,  51,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,  80,  81, 134, 135, 184, 185, 110, 111, 186, 187,
 108, 109,  82,  83, 132, 133, 124, 125, 170, 171, 148, 149,  66,  67,
 150, 151,  64,  65, 126, 127, 168, 169, 190, 191, 104, 105,  86,  87,
 128, 129,  84,  85, 130, 131, 188, 189, 106, 107, 146, 147,  68,  69,
 122, 123, 172, 173, 120, 121, 174, 175, 144, 145,  70,  71,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0, 116, 117, 162, 163, 156, 157,  74,  75,
 158, 159,  72,  73, 118, 119, 160, 161,  88,  89, 142, 143, 176, 177,
 102, 103, 178, 179, 100, 101,  90,  91, 140, 141, 154, 155,  76,  77,
 114, 115, 164, 165, 112, 113, 166, 167, 152, 153,  78,  79, 182, 183,
  96,  97,  94,  95, 136, 137,  92,  93, 138, 139, 180, 181,  98,  99,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,
   0,   0,   0,   0,   0,   0,   0,   0};

/*
Auto-generated table of square roots of the elements of GF(256).
*/

GFel SquareRoot[256] = {
   0,   1, 133, 132,   2,   3, 135, 134,  23,  22, 146, 147,  21,  20,
 144, 145,   4,   5, 129, 128,   6,   7, 131, 130,  19,  18, 150, 151,
  17,  16, 148, 149,  46,  47, 171, 170,  44,  45, 169, 168,  57,  56,
 188, 189,  59,  58, 190, 191,  42,  43, 175, 174,  40,  41, 173, 172,
  61,  60, 184, 185,  63,  62, 186, 187,   8,   9, 141, 140,  10,  11,
 143, 142,  31,  30, 154, 155,  29,  28, 152, 153,  12,  13, 137, 136,
  14,  15, 139, 138,  27,  26, 158, 159,  25,  24, 156, 157,  38,  39,
 163, 162,  36,  37, 161, 160,  49,  48, 180, 181,  51,  50, 182, 183,
  34,  35, 167, 166,  32,  33, 165, 164,  53,  52, 176, 177,  55,  54,
 178, 179,  92,  93, 217, 216,  94,  95, 219, 218,  75,  74, 206, 207,
  73,  72, 204, 205,  88,  89, 221, 220,  90,  91, 223, 222,  79,  78,
 202, 203,  77,  76, 200, 201, 114, 115, 247, 246, 112, 113, 245, 244,
 101, 100, 224, 225, 103, 102, 226, 227, 118, 119, 243, 242, 116, 117,
 241, 240,  97,  96, 228, 229,  99,  98, 230, 231,  84,  85, 209, 208,
  86,  87, 211, 210,  67,  66, 198, 199,  65,  64, 196, 197,  80,  81,
 213, 212,  82,  83, 215, 214,  71,  70, 194, 195,  69,  68, 192, 193,
 122, 123, 255, 254, 120, 121, 253, 252, 109, 108, 232, 233, 111, 110,
 234, 235, 126, 127, 251, 250, 124, 125, 249, 248, 105, 104, 236, 237,
 107, 106, 238, 239};
GFel Pow2[256] = {
   0,   1,   4,   5,  16,  17,  20,  21,  64,  65,  68,  69,  80,  81,
  84,  85,  29,  28,  25,  24,  13,  12,   9,   8,  93,  92,  89,  88,
  77,  76,  73,  72, 116, 117, 112, 113, 100, 101,  96,  97,  52,  53,
  48,  49,  36,  37,  32,  33, 105, 104, 109, 108, 121, 120, 125, 124,
  41,  40,  45,  44,  57,  56,  61,  60, 205, 204, 201, 200, 221, 220,
 217, 216, 141, 140, 137, 136, 157, 156, 153, 152, 208, 209, 212, 213,
 192, 193, 196, 197, 144, 145, 148, 149, 128, 129, 132, 133, 185, 184,
 189, 188, 169, 168, 173, 172, 249, 248, 253, 252, 233, 232, 237, 236,
 164, 165, 160, 161, 180, 181, 176, 177, 228, 229, 224, 225, 244, 245,
 240, 241,  19,  18,  23,  22,   3,   2,   7,   6,  83,  82,  87,  86,
  67,  66,  71,  70,  14,  15,  10,  11,  30,  31,  26,  27,  78,  79,
  74,  75,  94,  95,  90,  91, 103, 102,  99,  98, 119, 118, 115, 114,
  39,  38,  35,  34,  55,  54,  51,  50, 122, 123, 126, 127, 106, 107,
 110, 111,  58,  59,  62,  63,  42,  43,  46,  47, 222, 223, 218, 219,
 206, 207, 202, 203, 158, 159, 154, 155, 142, 143, 138, 139, 195, 194,
 199, 198, 211, 210, 215, 214, 131, 130, 135, 134, 147, 146, 151, 150,
 170, 171, 174, 175, 186, 187, 190, 191, 234, 235, 238, 239, 250, 251,
 254, 255, 183, 182, 179, 178, 167, 166, 163, 162, 247, 246, 243, 242,
 231, 230, 227, 226};
GFel Pow3[256] = {
   0,   1,   8,  15,  64,  85, 120, 107,  58, 115, 146, 221, 231, 186,
 127,  36, 205, 193, 191, 181, 228, 252, 166, 184, 107,  47, 185, 251,
 223, 143,  61, 107,  38, 115,  70,  21, 145, 208, 193, 134, 115, 110,
 179, 168,  89,  80, 169, 166, 127,  39, 101,  59, 161, 237, 139, 193,
 182, 166,  12,  26, 245, 241, 127, 125,  45, 161, 191,  53,  10, 146,
 168,  54, 252,  56, 206,  12,  70, 150,  68, 146, 191,  62,  87, 208,
 241, 100,  41, 186, 242,  59, 186, 117,  33, 252,  89, 130, 223,   7,
  37, 251,  15, 195, 197,  15,  97, 241,  59, 173,  44, 168,  70, 196,
 217,  12,  89, 138,  96, 161, 208,  23, 251, 102, 219,  64, 223,  86,
 207,  64, 117, 231,  97, 245, 145,  23, 181,  53,  80, 138, 228,  56,
  41, 231, 173, 101, 179,  44, 221,  68,  62, 181,  96, 237,  10, 221,
 196,  21,  26, 217, 228,  33, 145,  87, 237,  45, 130,  80, 206,  26,
 219,  85,   7, 143,  85, 207, 185,  37, 195,   8, 197,   8, 185, 102,
 143,  86,  21, 150, 179,  54, 242, 101, 100, 245, 182, 169,  56,  33,
  53,  62, 139, 134, 120,  47,  86,   7, 102,  37, 120,  61,  47,  61,
 219, 207, 197, 195,   1,   1, 125,  39,  41, 117,  10,  68, 110,  38,
 134, 205,  96,  45, 242, 173,  36, 125,  39,  36,  97, 100, 206, 217,
 184, 169, 139, 205,  23,  87, 150, 196,  58, 110, 182, 184, 138, 130,
  54,  44,  58,  38};
GFel Pow5[256] = {
   0,   1,  32,  51, 116, 108,  46,  36,  38, 226,   1, 215, 169, 116,
 244,  59, 180, 233,  17,  94,  32, 100, 255, 169, 132,  28,  38, 172,
 235, 106,  51, 160,   3, 150, 108, 235,  26, 150,  15, 145, 116,  36,
  28,  94, 150, 223, 132, 223,  77, 132, 167, 124, 180, 100,  36, 230,
  44,  32, 193, 223,  46,  59, 185, 190,  96, 174,  55, 235,   1, 214,
  44, 233, 103, 108,  55,  46, 253, 239, 215, 215,  38, 180, 244, 116,
 167,  44,  15, 150,  55,  96, 226, 167,  77,   3, 226, 190,  85,  15,
  77,   5,  89,  26,  59, 106,   3, 156,  28, 145, 244, 114, 145,   5,
 233, 239, 116,  96,   5,  26, 226, 239, 169, 106,  51, 226, 190, 100,
  94, 150, 156,   5, 100, 239, 174,  46,  44, 190,  32, 124, 223, 145,
 233, 172, 108,  59, 124, 185,   1, 214, 174, 114, 169, 103, 214, 214,
 172, 190, 255, 230, 255, 244, 180, 185,   3,  28, 235, 255,  38,  32,
  89, 145, 233,  51, 253,  44,  55, 244, 174, 255, 156, 223,  17,  89,
  89,   3,  85, 193,  96, 230,  17, 156,  94, 193, 114,  36, 253, 185,
  85,  26, 160, 253, 239, 124, 103, 230,  51, 185, 193,  89,  96, 106,
 106, 114, 167, 180, 215, 214, 235,  36, 230,  59, 215,   1, 160, 100,
 108, 174, 172, 124,  38, 253, 156,  85, 160, 167, 103, 114,  17,  15,
 172, 160, 132,  26, 193,  77,  46, 169,  17, 132,  94,   5,  28,  85,
  15,  77,  55, 103};
GFel Reciprocal[256] = {
   0,   1, 142, 244,  71, 167, 122, 186, 173, 157, 221, 152,  61, 170,
  93, 150, 216, 114, 192,  88, 224,  62,  76, 102, 144, 222,  85, 128,
 160, 131,  75,  42, 108, 237,  57,  81,  96,  86,  44, 138, 112, 208,
  31,  74,  38, 139,  51, 110,  72, 137, 111,  46, 164, 195,  64,  94,
  80,  34, 207, 169, 171,  12,  21, 225,  54,  95, 248, 213, 146,  78,
 166,   4,  48, 136,  43,  30,  22, 103,  69, 147,  56,  35, 104, 140,
 129,  26,  37,  97,  19, 193, 203,  99, 151,  14,  55,  65,  36,  87,
 202,  91, 185, 196,  23,  77,  82, 141, 239, 179,  32, 236,  47,  50,
  40, 209,  17, 217, 233, 251, 218, 121, 219, 119,   6, 187, 132, 205,
 254, 252,  27,  84, 161,  29, 124, 204, 228, 176,  73,  49,  39,  45,
  83, 105,   2, 245,  24, 223,  68,  79, 155, 188,  15,  92,  11, 220,
 189, 148, 172,   9, 199, 162,  28, 130, 159, 198,  52, 194,  70,   5,
 206,  59,  13,  60, 156,   8, 190, 183, 135, 229, 238, 107, 235, 242,
 191, 175, 197, 100,   7, 123, 149, 154, 174, 182,  18,  89, 165,  53,
 101, 184, 163, 158, 210, 247,  98,  90, 133, 125, 168,  58,  41, 113,
 200, 246, 249,  67, 215, 214,  16, 115, 118, 120, 153,  10,  25, 145,
  20,  63, 230, 240, 134, 177, 226, 241, 250, 116, 243, 180, 109,  33,
 178, 106, 227, 231, 181, 234,   3, 143, 211, 201,  66, 212, 232, 117,
 127, 255, 126, 253};
GFel EXP[255] = {
   1,   2,   4,   8,  16,  32,  64, 128,  29,  58, 116, 232, 205, 135,
  19,  38,  76, 152,  45,  90, 180, 117, 234, 201, 143,   3,   6,  12,
  24,  48,  96, 192, 157,  39,  78, 156,  37,  74, 148,  53, 106, 212,
 181, 119, 238, 193, 159,  35,  70, 140,   5,  10,  20,  40,  80, 160,
  93, 186, 105, 210, 185, 111, 222, 161,  95, 190,  97, 194, 153,  47,
  94, 188, 101, 202, 137,  15,  30,  60, 120, 240, 253, 231, 211, 187,
 107, 214, 177, 127, 254, 225, 223, 163,  91, 182, 113, 226, 217, 175,
  67, 134,  17,  34,  68, 136,  13,  26,  52, 104, 208, 189, 103, 206,
 129,  31,  62, 124, 248, 237, 199, 147,  59, 118, 236, 197, 151,  51,
 102, 204, 133,  23,  46,  92, 184, 109, 218, 169,  79, 158,  33,  66,
 132,  21,  42,  84, 168,  77, 154,  41,  82, 164,  85, 170,  73, 146,
  57, 114, 228, 213, 183, 115, 230, 209, 191,  99, 198, 145,  63, 126,
 252, 229, 215, 179, 123, 246, 241, 255, 227, 219, 171,  75, 150,  49,
  98, 196, 149,  55, 110, 220, 165,  87, 174,  65, 130,  25,  50, 100,
 200, 141,   7,  14,  28,  56, 112, 224, 221, 167,  83, 166,  81, 162,
  89, 178, 121, 242, 249, 239, 195, 155,  43,  86, 172,  69, 138,   9,
  18,  36,  72, 144,  61, 122, 244, 245, 247, 243, 251, 235, 203, 139,
  11,  22,  44,  88, 176, 125, 250, 233, 207, 131,  27,  54, 108, 216,
 173,  71, 142};
int LOG[256] = {
  -1,   0,   1,  25,   2,  50,  26, 198,   3, 223,  51, 238,  27, 104,
 199,  75,   4, 100, 224,  14,  52, 141, 239, 129,  28, 193, 105, 248,
 200,   8,  76, 113,   5, 138, 101,  47, 225,  36,  15,  33,  53, 147,
 142, 218, 240,  18, 130,  69,  29, 181, 194, 125, 106,  39, 249, 185,
 201, 154,   9, 120,  77, 228, 114, 166,   6, 191, 139,  98, 102, 221,
  48, 253, 226, 152,  37, 179,  16, 145,  34, 136,  54, 208, 148, 206,
 143, 150, 219, 189, 241, 210,  19,  92, 131,  56,  70,  64,  30,  66,
 182, 163, 195,  72, 126, 110, 107,  58,  40,  84, 250, 133, 186,  61,
 202,  94, 155, 159,  10,  21, 121,  43,  78, 212, 229, 172, 115, 243,
 167,  87,   7, 112, 192, 247, 140, 128,  99,  13, 103,  74, 222, 237,
  49, 197, 254,  24, 227, 165, 153, 119,  38, 184, 180, 124,  17,  68,
 146, 217,  35,  32, 137,  46,  55,  63, 209,  91, 149, 188, 207, 205,
 144, 135, 151, 178, 220, 252, 190,  97, 242,  86, 211, 171,  20,  42,
  93, 158, 132,  60,  57,  83,  71, 109,  65, 162,  31,  45,  67, 216,
 183, 123, 164, 118, 196,  23,  73, 236, 127,  12, 111, 246, 108, 161,
  59,  82,  41, 157,  85, 170, 251,  96, 134, 177, 187, 204,  62,  90,
 203,  89,  95, 176, 156, 169, 160,  81,  11, 245,  22, 235, 122, 117,
  44, 215,  79, 174, 213, 233, 230, 231, 173, 232, 116, 214, 244, 234,
 168,  80,  88, 175};
